## mingw-w64-webview-0.12.0-3.src.tar.zst

=== compatibility/CMakeLists.txt ===
if(WEBVIEW_USE_COMPAT_MINGW)
    add_subdirectory(mingw)
endif()

=== core/CMakeLists.txt ===
# Core header library
add_library(webview_core_headers INTERFACE)
add_library(webview::core ALIAS webview_core_headers)
target_include_directories(
    webview_core_headers
    INTERFACE
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
target_link_libraries(webview_core_headers INTERFACE ${WEBVIEW_DEPENDENCIES})
# Note that we also use CMAKE_CXX_STANDARD which can override this
target_compile_features(webview_core_headers INTERFACE cxx_std_11)
set_target_properties(webview_core_headers PROPERTIES
    EXPORT_NAME core)

if(CMAKE_SYSTEM_NAME STREQUAL "Windows" AND WEBVIEW_USE_COMPAT_MINGW)
    target_link_libraries(webview_core_headers INTERFACE webview::compat_mingw)
endif()

# Core shared library
if(WEBVIEW_BUILD_SHARED_LIBRARY)
    add_library(webview_core_shared SHARED)
    add_library(webview::core_shared ALIAS webview_core_shared)
    target_sources(webview_core_shared PRIVATE src/webview.cc)
    target_link_libraries(webview_core_shared PUBLIC webview_core_headers)
    set_target_properties(webview_core_shared PROPERTIES
        OUTPUT_NAME webview
        VERSION "${WEBVIEW_VERSION_NUMBER}"
        SOVERSION "${WEBVIEW_VERSION_COMPATIBILITY}"
        EXPORT_NAME core_shared)
    target_compile_definitions(webview_core_shared
        INTERFACE WEBVIEW_SHARED
        PRIVATE WEBVIEW_BUILD_SHARED)
endif()

# Core static library
if(WEBVIEW_BUILD_STATIC_LIBRARY)
    # Change .lib file name for MSVC because otherwise it would be the same for shared and static
    if(MSVC)
        set(STATIC_LIBRARY_OUTPUT_NAME webview_static)
    else()
        set(STATIC_LIBRARY_OUTPUT_NAME webview)
    endif()

    add_library(webview_core_static STATIC)
    add_library(webview::core_static ALIAS webview_core_static)
    target_sources(webview_core_static PRIVATE src/webview.cc)
    target_link_libraries(webview_core_static PUBLIC webview_core_headers)
    set_target_properties(webview_core_static PROPERTIES
        OUTPUT_NAME "${STATIC_LIBRARY_OUTPUT_NAME}"
        POSITION_INDEPENDENT_CODE ON
        EXPORT_NAME core_static)
    target_compile_definitions(webview_core_static PUBLIC WEBVIEW_STATIC)
endif()

if(WEBVIEW_BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== examples/CMakeLists.txt ===
find_package(Threads REQUIRED)

set(COPYRIGHT "Copyright [year], Your Name")
set(VENDOR "Your Name")
set(DESCRIPTION "Example app made with webview")
set(SHARED_SOURCES)

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    include(resources/macos/resources.cmake)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    include(resources/windows/resources.cmake)
endif()

add_executable(webview_example_basic_c MACOSX_BUNDLE WIN32)
target_sources(webview_example_basic_c PRIVATE basic.c ${SHARED_SOURCES})
target_link_libraries(webview_example_basic_c PRIVATE webview::core_static)

add_executable(webview_example_basic_cc MACOSX_BUNDLE WIN32)
target_sources(webview_example_basic_cc PRIVATE basic.cc ${SHARED_SOURCES})
target_link_libraries(webview_example_basic_cc PRIVATE webview::core)

add_executable(webview_example_bind_c MACOSX_BUNDLE WIN32)
target_sources(webview_example_bind_c PRIVATE bind.c ${SHARED_SOURCES})
target_link_libraries(webview_example_bind_c PRIVATE webview::core_static Threads::Threads)

if(MSVC)
    # Disable some warnings when using MSVC
    target_compile_definitions(webview_example_bind_c PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

add_executable(webview_example_bind_cc MACOSX_BUNDLE WIN32)
target_sources(webview_example_bind_cc PRIVATE bind.cc ${SHARED_SOURCES})
target_link_libraries(webview_example_bind_cc PRIVATE webview::core Threads::Threads)

=== packaging/CMakeLists.txt ===
set(CPACK_PACKAGE_NAME webview)
set(CPACK_PACKAGE_VENDOR webview organization)
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A tiny cross-platform webview library for C/C++ to build modern cross-platform GUIs")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}")
set(CPACK_RESOURCE_FILE_LICENSE ${PROJECT_SOURCE_DIR}/LICENSE)
set(CPACK_VERBATIM_VARIABLES TRUE)

string(TOLOWER "${CMAKE_GENERATOR_PLATFORM}" CMAKE_GENERATOR_PLATFORM_LC)
if(MSVC)
    if(CMAKE_GENERATOR_PLATFORM_LC STREQUAL "arm64")
        set(CMAKE_SYSTEM_PROCESSOR arm64)
    elseif(CMAKE_GENERATOR_PLATFORM_LC STREQUAL "amd64" OR CMAKE_GENERATOR_PLATFORM_LC STREQUAL "x64")
        set(CMAKE_SYSTEM_PROCESSOR x86_64)
    elseif(CMAKE_GENERATOR_PLATFORM_LC STREQUAL "win32" OR CMAKE_GENERATOR_PLATFORM_LC STREQUAL "x86")
        set(CMAKE_SYSTEM_PROCESSOR x86)
    endif()
endif()

string(TOLOWER "${CMAKE_SYSTEM_NAME}" CMAKE_SYSTEM_NAME_LC)
string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" CMAKE_SYSTEM_PROCESSOR_LC)
string(TOLOWER "${CMAKE_CXX_COMPILER_ID}" CMAKE_CXX_COMPILER_ID_LC)

if(MSVC AND MSVC_TOOLSET_VERSION)
    set(COMPILER_VERSION "${MSVC_TOOLSET_VERSION}")
else()
    string(REPLACE "." ";" COMPILER_VERSION_LIST "${CMAKE_CXX_COMPILER_VERSION}")
    list(GET COMPILER_VERSION_LIST 0 COMPILER_VERSION_MAJOR)
    list(GET COMPILER_VERSION_LIST 1 COMPILER_VERSION_MINOR)
    set(COMPILER_VERSION "${COMPILER_VERSION_MAJOR}.${COMPILER_VERSION_MINOR}")
endif()
set(COMPILER "${CMAKE_CXX_COMPILER_ID_LC}_${COMPILER_VERSION}")

if(WEBVIEW_USE_STATIC_MSVC_RUNTIME)
    set(RUNTIME_SUFFIX "-static_rt")
endif()

if(APPLE AND CMAKE_OSX_ARCHITECTURES MATCHES ";")
    set(PACKAGE_NAME_ARCH universal)
else()
    set(PACKAGE_NAME_ARCH ${CMAKE_SYSTEM_PROCESSOR_LC})
endif()

if((MSYS OR MINGW) AND DEFINED ENV{MSYSTEM})
    string(TOLOWER "$ENV{MSYSTEM}" MSYSTEM)
    set(MSYSTEM_SUFFIX "-${MSYSTEM}")
endif()

file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}" IGNORED_BUILD_DIR)
string(REPLACE "\\" "\\\\" IGNORED_BUILD_DIR "${IGNORED_BUILD_DIR}")
set(CPACK_SOURCE_IGNORE_FILES
    /\\.
    "^${IGNORED_BUILD_DIR}"
)
set(CPACK_SOURCE_GENERATOR TGZ)

# File names
set(WEBVIEW_ARCHIVE_SYSTEM_ARCH_FILE_NAME "${CPACK_PACKAGE_NAME}_v${CPACK_PACKAGE_VERSION}-${COMPILER}${MSYSTEM_SUFFIX}${RUNTIME_SUFFIX}-${CMAKE_SYSTEM_NAME_LC}-${PACKAGE_NAME_ARCH}")
set(WEBVIEW_ARCHIVE_UNIVERSAL_FILE_NAME "${CPACK_PACKAGE_NAME}_v${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${WEBVIEW_ARCHIVE_UNIVERSAL_FILE_NAME}-source")

# Set up custom packaging script for the "External" CPack generator
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/external_package.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/external_package.cmake" @ONLY)
set(CPACK_EXTERNAL_PACKAGE_SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/external_package.cmake")
set(CPACK_EXTERNAL_ENABLE_STAGING TRUE)

include(CPack)

=== test_driver/CMakeLists.txt ===
add_library(webview_test_driver STATIC)
target_sources(webview_test_driver PRIVATE src/test_driver.cc)
target_include_directories(webview_test_driver PUBLIC include)

=== compatibility/mingw/CMakeLists.txt ===
# Compatibility target for MinGW that can be used to work around missing
# "EventToken.h" header (used by MS WebView2) when targetting Windows.

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    add_library(webview_compat_mingw INTERFACE)
    add_library(webview::compat_mingw ALIAS webview_compat_mingw)
    set_target_properties(webview_compat_mingw PROPERTIES
        EXPORT_NAME compat_mingw)
    target_include_directories(
        webview_compat_mingw
        INTERFACE
            "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
            "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")
endif()

=== core/tests/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/test_driver/cmake/discovery.cmake)

if(MSVC)
    add_compile_options(/utf-8)
endif()

add_executable(webview_core_tests)
target_sources(webview_core_tests PRIVATE src/tests.cc)
target_link_libraries(webview_core_tests PRIVATE webview::core webview_test_driver)
webview_discover_tests(webview_core_tests)

=== docs/api/CMakeLists.txt ===
find_package(Doxygen REQUIRED dot)

# We can set this to "-$<CONFIG>" if we need per-config documentation
set(CONFIG_SUFFIX "")
set(DOXYFILE_HAVE_DOT YES)
set(DOXYFILE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/output${CONFIG_SUFFIX}")
set(DOXYFILE_CLANG_DATABASE_PATH "${PROJECT_BINARY_DIR}")

get_target_property(CORE_SOURCE_DIR webview::core SOURCE_DIR)
set(DOXYFILE_INPUT "${CORE_SOURCE_DIR}/include")

set(RUN_DOXYGEN_FILE "${CMAKE_CURRENT_BINARY_DIR}/run_doxygen${CONFIG_SUFFIX}.cmake")

file(GLOB_RECURSE DOCS_INPUT_FILES CONFIGURE_DEPENDS "${DOXYFILE_INPUT}/**")

file(GENERATE
    OUTPUT "${RUN_DOXYGEN_FILE}"
    CONTENT "set(DOXYGEN_EXECUTABLE \"${DOXYGEN_EXECUTABLE}\")\n\
set(PROJECT_NAME \"${PROJECT_NAME}\")\n\
set(PROJECT_VERSION \"${PROJECT_VERSION}\")\n\
set(PROJECT_DESCRIPTION \"${PROJECT_DESCRIPTION}\")\n\
set(DOXYFILE_HAVE_DOT \"${DOXYFILE_HAVE_DOT}\")\n\
set(DOXYFILE_OUTPUT_DIRECTORY \"${DOXYFILE_OUTPUT_DIRECTORY}\")\n\
set(DOXYFILE_INPUT \"${DOXYFILE_INPUT}\")\n\
set(DOXYFILE_CLANG_DATABASE_PATH \"${DOXYFILE_CLANG_DATABASE_PATH}\")\n\
configure_file(\"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in\" \"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile${CONFIG_SUFFIX}\" @ONLY)\n\
execute_process(COMMAND \"${DOXYGEN_EXECUTABLE}\" \"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile${CONFIG_SUFFIX}\")"
)

set(API_DOCS_STAMP_FILE "${CMAKE_CURRENT_BINARY_DIR}/webview_api_docs${CONFIG_SUFFIX}.stamp")
add_custom_command(
    OUTPUT "${API_DOCS_STAMP_FILE}"
    COMMAND "${CMAKE_COMMAND}" -E touch "${API_DOCS_STAMP_FILE}"
    COMMAND "${CMAKE_COMMAND}" -E rm -rf "${DOXYFILE_OUTPUT_DIRECTORY}"
    COMMAND "${CMAKE_COMMAND}" -P "${RUN_DOXYGEN_FILE}"
    DEPENDS ${DOCS_INPUT_FILES} "${RUN_DOXYGEN_FILE}"
    VERBATIM)

add_custom_target(webview_api_docs ALL DEPENDS "${API_DOCS_STAMP_FILE}")

if(WEBVIEW_INSTALL_DOCS)
    install(DIRECTORY "${DOXYFILE_OUTPUT_DIRECTORY}/html"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT webview_api_docs)
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=webview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-docs")
pkgver=0.12.0
pkgrel=3
pkgdesc="A tiny cross-platform webview library for C/C++ to build modern cross-platform GUIs. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/webview/webview'
msys2_repository_url='https://github.com/webview/webview'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-webview2-loader")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/webview/webview/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        '0001-webview-0.12.0-use-mdfile-as-mainpage.patch'
        '0002-webview-0.12.0-use-system-webview2.patch')
sha256sums=('e2c8d0bed3fcd13e624074448b7d3b1d0b0d03546a15839f17ee0013f2cba1db'
            '1f2bf8b3855cbfa59b17fc34efce8a40ccb3945bfe014c70466c235387296bd4'
            'b566fd4663602951294c1ee666333115094842e84024d344891456084a9e1234')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  patch -p1 -i "${srcdir}"/0001-webview-0.12.0-use-mdfile-as-mainpage.patch
  patch -p1 -i "${srcdir}"/0002-webview-0.12.0-use-system-webview2.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DWEBVIEW_BUILD_SHARED_LIBRARY=ON \
      -DWEBVIEW_BUILD_STATIC_LIBRARY=OFF \
      -DWEBVIEW_BUILD_DOCS=ON \
      -DWEBVIEW_INSTALL_DOCS=OFF \
      -DWEBVIEW_BUILD_EXAMPLES=OFF \
      -DWEBVIEW_BUILD_TESTS=OFF \
      -DWEBVIEW_ENABLE_CHECKS=OFF \
      -DWEBVIEW_ENABLE_PACKAGING=OFF \
      "${extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package_webview() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 ${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

package_webview-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mkdir -p "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}"
  cp -a "${srcdir}/build-${MSYSTEM}/docs/api/output/html" \
    "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/html"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;

# vim:set ts=2 sw=2 et:
